package nl.amis.spring.trial;
import org.springframework.aop.framework.ProxyFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class MyFirstAOP {
  public Employee getEmployee(boolean withValidation) {    
    Employee emp = new Employee();
    if (withValidation) {
      ProxyFactory pf = new ProxyFactory();
      pf.setTarget(emp);
      pf.addAdvice(new EmployeeValidator());
      return (Employee)pf.getProxy();
    }
    else {
      return emp;      
    }
  }

  public static void main(String[] args) {
    MyFirstAOP myFirstAOP = new MyFirstAOP();
    Employee scott = myFirstAOP.getEmployee(true);
    scott.setFirstName("Johnny");
    scott.setLastName("Doe");
    scott.setJobTitle("SALESMAN");
    
    scott.setSalary(new Float("5000.32"));
    System.out.println("The new salary for "+scott.getFirstName()+" "+scott.getLastName()+" ("+scott.getJobTitle()+") = "+scott.getSalary());
  }
}