package nl.amis.spring.jdbc;

import java.sql.*;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import nl.amis.spring.hrm.EmpDAO;
import nl.amis.spring.hrm.Employee;
public class JDBCWithoutSpring implements EmpDAO  {

 public JDBCWithoutSpring() {
  }
public long getSalarySum() { return 0;}
   
    public List getAllEmployees() {
        Connection con = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;
        List emps = new ArrayList();
        try {
            con = getConnection();
            pstmt = con.prepareStatement 
                        ("select ename, job from emp");
            rs = pstmt.executeQuery();
            while (rs.next()) {
                Employee e = new Employee();
                e.setLastName(rs.getString(1));
                e.setJobTitle(rs.getString(2));
                emps.add(e);
            }
        } catch (SQLException e) {
            // handle exception
        } finally {
            try {
                rs.close();
                pstmt.close();
                con.close();
            } catch (SQLException e1) {
                // no action needed
            }
        }
        return emps;
    }
    
  private Connection getConnection() throws SQLException  {
    try {
        DriverManager.registerDriver 
            (new oracle.jdbc.driver.OracleDriver());
        return DriverManager.getConnection
            ("jdbc:oracle:thin:@localhost:1521:orcl"
             ,"scott", "tiger");
    } catch (SQLException sqle) {   
        // handle exception
        return null;
    }
  }// getConnection

  public static void main(String[] args)  throws Exception {
    JDBCWithoutSpring empDAO = new JDBCWithoutSpring();
    List emps = empDAO.getAllEmployees();
    Iterator empIter = emps.iterator();
    while (empIter.hasNext()) {
      Employee emp = (Employee)empIter.next();
      System.out.println(emp.getLastName()+" ("+emp.getJobTitle()+")");
    }//while
  }//main
}


